import { generateNewAnimationId, shouldUseNativeDriver } from "../NativeAnimatedHelper";
import AnimatedNode from "./AnimatedNode";
function _assert_this_initialized(self) {
  if (self === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return self;
}
function _class_call_check(instance, Constructor) {
  if (!(instance instanceof Constructor))
    throw new TypeError("Cannot call a class as a function");
}
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || !1, descriptor.configurable = !0, "value" in descriptor && (descriptor.writable = !0), Object.defineProperty(target, descriptor.key, descriptor);
  }
}
function _create_class(Constructor, protoProps, staticProps) {
  return protoProps && _defineProperties(Constructor.prototype, protoProps), staticProps && _defineProperties(Constructor, staticProps), Constructor;
}
function _define_property(obj, key, value) {
  return key in obj ? Object.defineProperty(obj, key, {
    value,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : obj[key] = value, obj;
}
function _get(target, property, receiver) {
  return typeof Reflect < "u" && Reflect.get ? _get = Reflect.get : _get = function(target2, property2, receiver2) {
    var base = _super_prop_base(target2, property2);
    if (base) {
      var desc = Object.getOwnPropertyDescriptor(base, property2);
      return desc.get ? desc.get.call(receiver2 || target2) : desc.value;
    }
  }, _get(target, property, receiver || target);
}
function _get_prototype_of(o) {
  return _get_prototype_of = Object.setPrototypeOf ? Object.getPrototypeOf : function(o2) {
    return o2.__proto__ || Object.getPrototypeOf(o2);
  }, _get_prototype_of(o);
}
function _inherits(subClass, superClass) {
  if (typeof superClass != "function" && superClass !== null)
    throw new TypeError("Super expression must either be null or a function");
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: !0,
      configurable: !0
    }
  }), superClass && _set_prototype_of(subClass, superClass);
}
function _object_spread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {}, ownKeys2 = Object.keys(source);
    typeof Object.getOwnPropertySymbols == "function" && (ownKeys2 = ownKeys2.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
      return Object.getOwnPropertyDescriptor(source, sym).enumerable;
    }))), ownKeys2.forEach(function(key) {
      _define_property(target, key, source[key]);
    });
  }
  return target;
}
function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function(sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}
function _object_spread_props(target, source) {
  return source = source ?? {}, Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function(key) {
    Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
  }), target;
}
function _possible_constructor_return(self, call) {
  return call && (_type_of(call) === "object" || typeof call == "function") ? call : _assert_this_initialized(self);
}
function _set_prototype_of(o, p) {
  return _set_prototype_of = Object.setPrototypeOf || function(o2, p2) {
    return o2.__proto__ = p2, o2;
  }, _set_prototype_of(o, p);
}
function _super_prop_base(object, property) {
  for (; !Object.prototype.hasOwnProperty.call(object, property) && (object = _get_prototype_of(object), object !== null); )
    ;
  return object;
}
function _type_of(obj) {
  "@swc/helpers - typeof";
  return obj && typeof Symbol < "u" && obj.constructor === Symbol ? "symbol" : typeof obj;
}
function _is_native_reflect_construct() {
  if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham) return !1;
  if (typeof Proxy == "function") return !0;
  try {
    return Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    })), !0;
  } catch {
    return !1;
  }
}
function _create_super(Derived) {
  var hasNativeReflectConstruct = _is_native_reflect_construct();
  return function() {
    var Super = _get_prototype_of(Derived), result;
    if (hasNativeReflectConstruct) {
      var NewTarget = _get_prototype_of(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else
      result = Super.apply(this, arguments);
    return _possible_constructor_return(this, result);
  };
}
var AnimatedTracking = /* @__PURE__ */ function(AnimatedNode2) {
  _inherits(AnimatedTracking2, AnimatedNode2);
  var _super = _create_super(AnimatedTracking2);
  function AnimatedTracking2(value, parent, animationClass, animationConfig, callback) {
    _class_call_check(this, AnimatedTracking2);
    var _this;
    return _this = _super.call(this), _this._value = value, _this._parent = parent, _this._animationClass = animationClass, _this._animationConfig = animationConfig, _this._useNativeDriver = shouldUseNativeDriver(animationConfig), _this._callback = callback, _this.__attach(), _this;
  }
  return _create_class(AnimatedTracking2, [
    {
      key: "__makeNative",
      value: function() {
        this.__isNative = !0, this._parent.__makeNative(), _get(_get_prototype_of(AnimatedTracking2.prototype), "__makeNative", this).call(this), this._value.__makeNative();
      }
    },
    {
      key: "__getValue",
      value: function() {
        return this._parent.__getValue();
      }
    },
    {
      key: "__attach",
      value: function() {
        this._parent.__addChild(this), this._useNativeDriver && this.__makeNative();
      }
    },
    {
      key: "__detach",
      value: function() {
        this._parent.__removeChild(this), _get(_get_prototype_of(AnimatedTracking2.prototype), "__detach", this).call(this);
      }
    },
    {
      key: "update",
      value: function() {
        this._value.animate(new this._animationClass(_object_spread_props(_object_spread({}, this._animationConfig), {
          toValue: this._animationConfig.toValue.__getValue()
        })), this._callback);
      }
    },
    {
      key: "__getNativeConfig",
      value: function() {
        var animation = new this._animationClass(_objectSpread(_objectSpread({}, this._animationConfig), {}, {
          // remove toValue from the config as it's a ref to Animated.Value
          toValue: void 0
        })), animationConfig = animation.__getNativeAnimationConfig();
        return {
          type: "tracking",
          animationId: generateNewAnimationId(),
          animationConfig,
          toValue: this._parent.__getNativeTag(),
          value: this._value.__getNativeTag()
        };
      }
    }
  ]), AnimatedTracking2;
}(AnimatedNode), AnimatedTracking_default = AnimatedTracking;
export {
  AnimatedTracking_default as default
};
//# sourceMappingURL=AnimatedTracking.js.map
